import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { useState } from 'react';
import classnames from "classnames";

require('./page-selector.css').toString();

function PageThumbnail(_ref) {
  var src = _ref.src,
      isActive = _ref.isActive,
      onClick = _ref.onClick,
      pageNumber = _ref.pageNumber;
  return React.createElement("div", {
    role: "button",
    tabIndex: 0,
    className: classnames('page-thumbnail', {
      'page-thumbnail-is-active': isActive
    }),
    onClick: onClick
  }, React.createElement("img", {
    src: src,
    alt: ""
  }), pageNumber !== undefined && React.createElement("div", {
    className: "page-number-wrapper"
  }, React.createElement("span", {
    className: "page-number"
  }, pageNumber)));
}

function PageSelector(_ref2) {
  var pages = _ref2.pages,
      onPageClick = _ref2.onPageClick,
      onRecalc = _ref2.onRecalc,
      onSave = _ref2.onSave,
      recalcActive = _ref2.recalcActive,
      saveActive = _ref2.saveActive,
      onMetadataChange = _ref2.onMetadataChange;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      showMetadata = _useState2[0],
      setShowMetadata = _useState2[1];

  return React.createElement("div", {
    className: classnames('page-selector', {
      'page-selector--opened': showMetadata
    })
  }, React.createElement("div", {
    className: "top-buttons"
  }, React.createElement("button", {
    onClick: onRecalc,
    disabled: !recalcActive,
    className: "info"
  }, "Recalc"), React.createElement("button", {
    onClick: onSave,
    disabled: !saveActive,
    className: "success"
  }, "Save")), React.createElement("div", {
    className: "pages"
  }, pages.map(function (page, idx) {
    var _page$metadata;

    return React.createElement("div", {
      className: "page-thumbnail__wrapper"
    }, React.createElement(PageThumbnail, {
      key: page.id,
      src: page.src,
      isActive: page.isActive,
      onClick: function onClick() {
        return onPageClick(idx);
      }
    }), showMetadata && React.createElement("div", {
      className: "page-thumbnail__metadata"
    }, React.createElement("h5", null, "Metadata"), page === null || page === void 0 ? void 0 : (_page$metadata = page.metadata) === null || _page$metadata === void 0 ? void 0 : _page$metadata.map(function (_ref3) {
      var key = _ref3.key,
          value = _ref3.value;
      return React.createElement(React.Fragment, null, React.createElement("label", {
        htmlFor: key
      }, key), React.createElement("input", {
        id: key,
        type: "text",
        value: value,
        onChange: function onChange(e) {
          return onMetadataChange({
            name: key,
            value: e.target.value,
            imageIndex: idx
          });
        }
      }));
    })));
  })), React.createElement("div", {
    className: "bottom-buttons"
  }, React.createElement("div", {
    className: "show-metadata-wrapper"
  }, React.createElement("label", {
    className: "switch mr-2"
  }, React.createElement("input", {
    id: "show-metadata",
    type: "checkbox",
    value: showMetadata,
    onChange: function onChange() {
      return setShowMetadata(function (prev) {
        return !prev;
      });
    }
  }), React.createElement("span", {
    className: "slider round"
  })), React.createElement("label", null, "Metadata"))));
}

PageSelector.defaultProps = {
  onPageClick: function onPageClick() {},
  onRecalc: function onRecalc() {},
  onSave: function onSave() {},
  recalcActive: false,
  saveActive: false,
  pageNumber: undefined
};
export default PageSelector;