function labelAndTextFromResultText(resultText) {
  if (!resultText) {
    return {};
  }

  var parsedResultText = JSON.parse(resultText);
  var label = parsedResultText[0].label;
  var text = parsedResultText[0].text;
  return {
    label: label,
    text: text
  };
}

function modelResultsToRegions(modelResults) {
  return modelResults.map(function (r) {
    var _labelAndTextFromResu = labelAndTextFromResultText(r.text),
        label = _labelAndTextFromResu.label,
        text = _labelAndTextFromResu.text;

    return {
      id: r.id,
      type: "box",
      visible: true,
      cls: label,
      highlighted: false,
      groupHighlighted: false,
      x: r.box.X1,
      y: r.box.Y1,
      w: r.box.X2 - r.box.X1,
      h: r.box.Y2 - r.box.Y1,
      groupId: r.groupId,
      text: text
    };
  });
}

function photosToImages(photos) {
  return photos.map(function (photo) {
    return {
      id: photo.id,
      src: photo.fullsize.key,
      thumbnail: photo.thumbnail.key,
      name: photo.fullsize.key,
      regions: modelResultsToRegions(photo.modelResults.v1.filter(function (mr) {
        return mr.name === 'extraction-engine';
      })[0].results),
      metadata: photo.metadata
    };
  });
}

export default photosToImages;